#ifndef _FILESTORE_H_
#define _FILESTORE_H_

#include "PageStore.h"

class FileStore {
    private:
       int 		begin_fid;
       int      	current_fid;
       PageStore *	pageStore;
       

       int 		scan_fid;
       int 		scan_rid;
       PageStore *      scan_page;

       char 		fileName[20];
       
       char *		getFileName(int fid);

    public:
        FileStore();
       ~FileStore();

       bool insertRecord(char *record, unsigned short rec_size,
                         int & fid, unsigned short &rid);
       int createNewFile();
       bool getRecord(char *&record, unsigned short &rec_size,
                      int fid, unsigned short rid);
       bool copyRecord(char *&record, unsigned short &rec_size,
		      int fid, unsigned short rid);
       
       bool removeFile(int fid);

       bool getOldID(int fid, int rid, int &yuanFid, int &yuanEid);

       int  beginScan(char * &record, unsigned short & size, int &fid, unsigned short & rid);
       int  getNext(char *&  record, unsigned short & size, int &fid, unsigned short & rid );
};

#endif
