#ifndef _LOCATION_H_
#define _LOCATION_H_

class Location {
    
    private: 
       int *location;
       int level;
    
    public:
        Location();
	Location(int);
        Location(int *, int);
        //Location(Location &);
        Location(Location *);

       ~Location();

       Location getFatherLocation();
       Location getChildrenLocation(int child_position);
       Location getNextBrotherLocation();
       
       Location * createAttributeLocation(int pos);
       int  getLevel();
       
       void increaseLevel();
       void decreaseLevel();
       void growInSameLevel();
       void decreaseInSameLevel();

       bool sameLocation(Location *loc);
       bool isFatherOf(Location *loc);
       bool isChildrenOf(Location *loc);
       bool isBrotherOf(Location *loc);
        
       bool isFirstChild();
       bool isRoot();
       
       void  getLocationNumber(int *, int &);
       int   getLocationSum();
       
       char* toStoreString(int &);
       void  toStoreString(char *, int &);
       
       void  copyLocation(Location *);
       void  dump();
};
#endif
