#ifndef _LOCATIONLIST_H_
#define _LOCATIONLIST_H_

#include "Location.h"

typedef struct {
   
   Location * 	loc;
   void *	next;
}Location_record;


class LocationList {
     private:
	int size;
	Location_record * current;
	Location_record * header;
	Location_record * tailer;

     public:
        LocationList();
	~LocationList();

	void insertLocation(Location * loc);
        
	Location * getNext();
        void       initCurrent();	
	void dump();
	
};

#endif
