#ifndef __BUFFERVECTOR__
#define __BUFFERVECTOR__

#include "constant.h"

class BufferVector{
	public:
		BufferVector(int unitSize);
		~BufferVector();

		void addValue(char* buf);
		void addValues(char* buf, int recordCount);
		char* getBuffer();
		int getSize();
		void deleteBuffer();
		char* getElement(int);

	private:
		char* buffer;
		int size;
		int maxSize;
		int unitSize;
};

#endif
