#include <stdio.h>
#include <string.h>

#include "FileStore.h"
#include "RecordStore.h"

int main(){
   int size;
   Location *loc;
   
   char * eName;
   char * content;
   
   RecordStore recordStore = RecordStore();
   FileStore   fileStore   = FileStore();
   
   for (int j=0;j<1;j++){
      eName  = new char [strlen("improcessing")+1];
      strcpy(eName,"improcessing"); 
      recordStore.createRecord(eName,0,j);
      delete [] eName;
      
      eName  = strdup("key");
      content = strdup("conf_sigmod_Mylopoulos80");
      recordStore.addAttribute(1,eName,content);
      free(eName);
      free(content);
      ////////////////////////
      recordStore.goToNextLevel();
      eName = strdup("author");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("John Mylopoulos");
      recordStore.addElementContent(content);
      free(content);
      
      recordStore.finishElement();
      //////////////////////////////////
      eName = strdup("title");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("An Overview of Knowledge Representation.");
      recordStore.addElementContent(content);
      free(content);
      
      recordStore.finishElement();

      //////////////////////////////////
      eName = strdup("pages");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("5-12");
      recordStore.addElementContent(content);
      free(content);
      
      recordStore.finishElement();

      ////////////////////////////////////////
      eName = strdup("year");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("1980");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();

      ////////////////////////////////////////

      ////////////////////////////////////////
      eName = strdup("booktitle");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("Workshop on Data Abstraction, Databases and Conceptual Modelling");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();

      ////////////////////////////////////////

      eName = strdup("url");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("db/conf/sigmod/pingree80.html#Mylopoulos80");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();

      ////////////////////////////////////////

      recordStore.finishThisLevel();

      char * st =recordStore.finishRecord(size);
///////////////////////////////////////////////////////////////
// dump out the record

      printf("size = %d\n",size);

      for (int i=0;i<size;i++) {
         printf("%d ",(int)st[i]);
         if ((i+1)%15==0) printf("\n");
      }
      printf("\n");

      char * path[2] ={"improcessing","author"};
      char ** result;
      int count;

      recordStore.loadValue(st,size, path,1 ,result,count);
      printf(" find %d result\n",count);
      for (int i=0;i<count;i++) printf("%s\n",result[i]);

      for (int i=0;i<count;i++) delete [] result[i];
      delete [] result;
      int fid;
      unsigned short rid;
      fileStore.insertRecord(st, (unsigned short)size, fid, rid);
printf("insert in : %d %d\n",fid,rid);  

      // delete record
      delete [] st;
   }

   for (int j=0;j<2;j++){
      
      eName  = new char [strlen("improcessing")+1];
      strcpy(eName,"improcessing"); 
      recordStore.createRecord(eName,0,j);
      delete [] eName;
      
      eName  = strdup("key");
      content = strdup("conf_sigmod_SantosFCC80");
      recordStore.addAttribute(1,eName,content);
      free(eName);
      free(content);
      //////////////////////////////////////////
      recordStore.goToNextLevel();
      
      eName = strdup("author");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("Clesio Saraiva dos Santos");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////

      eName = strdup("author");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("Antonio L. Furtado");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////
      eName = strdup("author");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("Jos Mauro V. de Castilho");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////

      eName = strdup("author");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("Sergio E. R. de Carvalho");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////

      eName = strdup("title");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("Towards Constructive Axiomatic Specifications.");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////

      eName = strdup("pages");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("183-185");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////

      eName = strdup("year");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("1980");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////
      
      eName = strdup("booktitle");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("Workshop on Data Abstraction, Databases and Conceptual Modelling");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      //////////////////////////////////////////////
      
       eName = strdup("url");
      recordStore.createElement(eName);
      free(eName);

      content = strdup("db/conf/sigmod/pingree80.html#SantosFCC80");
      recordStore.addElementContent(content);
      free(content);
       
      recordStore.finishElement();
      /////////////////////////////////////////////
      recordStore.finishThisLevel();
      char * st =recordStore.finishRecord(size); 
   
      printf("size = %d\n",size);
      /*for (int i=0;i<size;i++) {
         printf("%d ",(int)st[i]);
         if ((i+1)%15==0) printf("\n");
      }
      printf("\n");*/

      int fid;
      unsigned short rid;
      fileStore.insertRecord(st, (unsigned short)size, fid, rid);
printf("insert in : %d %d\n",fid,rid); 

      delete [] st;
   }

   return 0;
}
