#ifndef __SEARCHNODE__
#define __SEARCHNODE__

#include "constant.h"
#include "head.h"

class SearchNode {
	public:
		SearchNode(char* filename, char* prefix);
		SearchNode(char* filename, char* prefix, char& tag);
		~SearchNode();
		void reset(char* filename); 
		void searchBT(char* key, int op, int*& fids, ushort*& eids, 
						int*& wfids, ushort*& weids, int& length); 
		void searchEntry(int fileNum, ushort offset, int op, int*& fids, ushort*& eids, 
						int*& wfids, ushort*& weids, int& length); 
		void searchBT(char* key, int op, char*& buf, int& length); 
		void searchEntry(int fileNum, ushort offset, int op,char*& buf, int& length); 
		int keyCompare(char* key1, char* key2);


	private:
		char nodeType;
		char keyType;
		int keyLen;
		int otherLen;
		char* data;
		int dataLen;
		char* prefix;
		int next;
		int first;
};

#endif
