
#ifndef __SORT__
#define __SORT__


#include "constant.h"
#include "head.h"
#include "runfile.h"
#include "buildbtree.h"
#include "map.h"

class Sort
{
 public:

    Sort(int num_of_field, char* fieldType, int* fieldSize, 
					char** prefix, int amt_of_buf);

    ~Sort();

	void insertRecord(int field_no, int fid, ushort eid, 
				int wfid, ushort weid, char* value); 

	void Run(); 

	void debug();
 private: 

	char* field_type; // the type of each field
	int amt_of_field; // the total number of fields
	int* field_size;  // the size of each field
	int* record_len;
	int id_len;

	char* sort_area;
	int max_offset;
	int current_offset;
	int amt_of_buf;

	int file_no; // how many initial files were written to disk

	int record_count;

	int current_sort_offset;
	int current_sort_no;

	int sizeofInt;
	int sizeofShort;

	BuildBTree** btrees;
	RunFile** runfile;
	Map* map;
	int currentFid;
	ushort currentEid;

	void Step0();

	void OtherStep(int);

	void Pass(int , int& ,int ,char& ); 
    
	void one_merge(RunFile** , RunFile* ,int ,int);

	void genFileName(int, int , int , char*& ,int =0);

};


#endif
