#ifndef __SEARCHBTREE__
#define __SEARCHBTREE__

#include "searchnode.h"

class SearchBTree {
	public:
		SearchBTree(char* prefix, char& tag); //0---successful
		~SearchBTree();

		void search(char* key, int op, int*& fids, ushort*& eids, 
				int*& wfids, ushort*& weids, int&length);
		void search(char* key, int op, char*& buf, int&length); 

	private:
		SearchNode* root;
		char* prefix;
		char* rootFileName;

};

#endif
